/**
 * INRIA/IRISA
 *
 * $Id: ClassificationItemProviderAdapterFactory.java,v 1.1 2008-04-01 09:35:49 vmahe Exp $
 */
package orgomg.cwm.analysis.datamining.classification.provider;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

import orgomg.cwm.analysis.datamining.classification.util.ClassificationAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ClassificationItemProviderAdapterFactory extends ClassificationAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "INRIA/IRISA";

	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ClassificationItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link orgomg.cwm.analysis.datamining.classification.ApplyTargetValueItem} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ApplyTargetValueItemItemProvider applyTargetValueItemItemProvider;

	/**
	 * This creates an adapter for a {@link orgomg.cwm.analysis.datamining.classification.ApplyTargetValueItem}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createApplyTargetValueItemAdapter() {
		if (applyTargetValueItemItemProvider == null) {
			applyTargetValueItemItemProvider = new ApplyTargetValueItemItemProvider(this);
		}

		return applyTargetValueItemItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link orgomg.cwm.analysis.datamining.classification.ClassificationAttributeUsage} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ClassificationAttributeUsageItemProvider classificationAttributeUsageItemProvider;

	/**
	 * This creates an adapter for a {@link orgomg.cwm.analysis.datamining.classification.ClassificationAttributeUsage}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createClassificationAttributeUsageAdapter() {
		if (classificationAttributeUsageItemProvider == null) {
			classificationAttributeUsageItemProvider = new ClassificationAttributeUsageItemProvider(this);
		}

		return classificationAttributeUsageItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link orgomg.cwm.analysis.datamining.classification.ClassificationFunctionSettings} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ClassificationFunctionSettingsItemProvider classificationFunctionSettingsItemProvider;

	/**
	 * This creates an adapter for a {@link orgomg.cwm.analysis.datamining.classification.ClassificationFunctionSettings}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createClassificationFunctionSettingsAdapter() {
		if (classificationFunctionSettingsItemProvider == null) {
			classificationFunctionSettingsItemProvider = new ClassificationFunctionSettingsItemProvider(this);
		}

		return classificationFunctionSettingsItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link orgomg.cwm.analysis.datamining.classification.ClassificationTestResult} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ClassificationTestResultItemProvider classificationTestResultItemProvider;

	/**
	 * This creates an adapter for a {@link orgomg.cwm.analysis.datamining.classification.ClassificationTestResult}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createClassificationTestResultAdapter() {
		if (classificationTestResultItemProvider == null) {
			classificationTestResultItemProvider = new ClassificationTestResultItemProvider(this);
		}

		return classificationTestResultItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link orgomg.cwm.analysis.datamining.classification.ClassificationTestTask} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ClassificationTestTaskItemProvider classificationTestTaskItemProvider;

	/**
	 * This creates an adapter for a {@link orgomg.cwm.analysis.datamining.classification.ClassificationTestTask}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createClassificationTestTaskAdapter() {
		if (classificationTestTaskItemProvider == null) {
			classificationTestTaskItemProvider = new ClassificationTestTaskItemProvider(this);
		}

		return classificationTestTaskItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link orgomg.cwm.analysis.datamining.classification.PriorProbabilities} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PriorProbabilitiesItemProvider priorProbabilitiesItemProvider;

	/**
	 * This creates an adapter for a {@link orgomg.cwm.analysis.datamining.classification.PriorProbabilities}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPriorProbabilitiesAdapter() {
		if (priorProbabilitiesItemProvider == null) {
			priorProbabilitiesItemProvider = new PriorProbabilitiesItemProvider(this);
		}

		return priorProbabilitiesItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link orgomg.cwm.analysis.datamining.classification.PriorProbabilitiesEntry} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PriorProbabilitiesEntryItemProvider priorProbabilitiesEntryItemProvider;

	/**
	 * This creates an adapter for a {@link orgomg.cwm.analysis.datamining.classification.PriorProbabilitiesEntry}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPriorProbabilitiesEntryAdapter() {
		if (priorProbabilitiesEntryItemProvider == null) {
			priorProbabilitiesEntryItemProvider = new PriorProbabilitiesEntryItemProvider(this);
		}

		return priorProbabilitiesEntryItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class) || (((Class<?>)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void dispose() {
		if (applyTargetValueItemItemProvider != null) applyTargetValueItemItemProvider.dispose();
		if (classificationAttributeUsageItemProvider != null) classificationAttributeUsageItemProvider.dispose();
		if (classificationFunctionSettingsItemProvider != null) classificationFunctionSettingsItemProvider.dispose();
		if (classificationTestResultItemProvider != null) classificationTestResultItemProvider.dispose();
		if (classificationTestTaskItemProvider != null) classificationTestTaskItemProvider.dispose();
		if (priorProbabilitiesItemProvider != null) priorProbabilitiesItemProvider.dispose();
		if (priorProbabilitiesEntryItemProvider != null) priorProbabilitiesEntryItemProvider.dispose();
	}

}
